package inject

import (
    "cygnux/kepler/models/metas"
    //"cygnux/kepler/models"
)

/*
class CategoryAlbum(DeclarativeDeneb):
    __tablename__ = 'metas_category_albums'
    # {
    # id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    categoryId = Column('category_id', UUID,
                        ForeignKey(Category.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                        primary_key=True)
    albumId = Column('album_id', UUID,
                     ForeignKey(Album.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                     primary_key=True)
    index = Column('idx', Integer, nullable=False, default=0)
    status = Column(SmallInteger, nullable=False, default=0)
    # }
    category = relationship('Category', uselist=False, backref=backref("albums"))
    album = relationship('Album', uselist=False, backref=backref("category_list"))
*/
type CategoryAlbum struct {
    metas.CategoryAlbum
}
/*
class Album(DeclarativeDeneb):
    __tablename__ = 'metas_albums'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    albumName = Column('album_name', Unicode(256), index=True, nullable=False)
    index = Column('idx', Integer, nullable=False, index=True, default=0)
    isSeries = Column('is_series', Boolean, nullable=False, default=False)
    filmTotal = Column('film_total', Integer, nullable=False, default=1)
    filmCount = Column('film_count', Integer, nullable=False, default=1)
    remark = Column('remark', Unicode(256), nullable=False, default=u"")
    issueDate = Column('issue_date', Date, nullable=False)
    publishTime = Column('publish_time', DateTime, nullable=False)
    score = Column(Numeric(3, 1), nullable=False, default=3.0)
    # zone = Column(Unicode, nullable=False, default=u'')
    contentRating = Column('content_rating', String(16), nullable=True)
    albumPicture = Column('album_pic', String(256), nullable=False, default="")
    providerId = Column("provider_id", UUID,
                        ForeignKey(Provider.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                        nullable=False)
    imdbId = Column("imdb_id", String(24), nullable=True)
    cpRefId = Column("cp_ref_id", String(64), nullable=True)
    description = Column(UnicodeText, nullable=False, default=u"")
    status = Column(SmallInteger, nullable=False,default=0)
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
    provider = relation('Provider', uselist=False)
*/
type Album struct {
    metas.Album
    CategoryId    string `json:",omitempty" xql:"-"`
    Tags          []string `json:"tags,omitempty" xql:"-"`
    Geniuses      []string `json:"geniuses,omitempty" xql:"-"`
    Crews         []Crew `json:"crews,omitempty" xql:"-"`
    Films         []Film `json:"films,omitempty" xql:"-"`
}

/*
class Film(DeclarativeDeneb):
    __tablename__ = 'metas_films'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    filmName = Column('film_name', Unicode(256), index=True, nullable=False)
    remark = Column('remark', Unicode(256), nullable=False, default=u"")
    filmPicture = Column('film_pic', String(256), nullable=False, default="")
    language = Column(Unicode, nullable=False, default=u'')
    duration = Column(Integer, nullable=False, default=0)
    issueDate = Column('issue_date', Date, nullable=False)
    publishTime = Column('publish_time', DateTime, nullable=False)
    cpRefId = Column("cp_ref_id", String(64), nullable=True)
    description = Column(UnicodeText, nullable=False, default=u"")
    status = Column(SmallInteger, nullable=False, default=0)
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
*/
type Film struct {
    metas.Film
    Index         int `json:"index" xql:"-"`
    Crews         []Crew `json:"crews,omitempty" xql:"-"`
    Videos        []Video `json:"videos,omitempty" xql:"-"`
    ScreenShots   []string `json:"screenShots,omitempty" xql:"-"`
}

/*
class AlbumFilm(DeclarativeDeneb):
    __tablename__ = 'metas_album_films'
    # {
    # id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    albumId = Column('album_id', UUID,
                     ForeignKey(Album.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                     primary_key=True)
    filmId = Column('film_id', UUID,
                    ForeignKey(Film.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                    primary_key=True)
    index = Column('idx', Integer, nullable=False, default=1)
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
    album = relation('Album', uselist=False, backref=backref("films"))
    film = relation('Film', uselist=False)
*/
type AlbumFilm struct {
    metas.AlbumFilm
}
/*
class AlbumTag(DeclarativeDeneb):
    __tablename__ = "metas_album_tags"
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    albumId = Column('album_id', UUID,
                     ForeignKey(Album.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                     nullable=False)
    tag = Column(Unicode(32), nullable=False, default=u"")
    # }
    album = relation('Album', uselist=False, backref=backref("tags"))
*/
type AlbumTag struct {
    metas.AlbumTag
}
/*
class AlbumGenius(DeclarativeDeneb):
    __tablename__ = "metas_album_geniuses"
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    albumId = Column('album_id', UUID,
                     ForeignKey(Album.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                     nullable=False)
    genius = Column(Unicode(32), nullable=False, default=u"")
    # }
    album = relation('Album', uselist=False, backref=backref("geniuses"))
*/
type AlbumGenius struct {
    metas.AlbumGenius
}
/*
class Crew(DeclarativeDeneb):
    __tablename__ = "metas_crews"
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    fullName = Column('fullname', Unicode(64), nullable=False)
    firstName = Column('first_name', Unicode(32), nullable=True)
    middleName = Column('middle_name', Unicode(32), nullable=True)
    lastName = Column('last_name', Unicode(32), nullable=True)
    region = Column(Unicode(64), nullable=True)
    imdbId = Column("imdb_id", String(24), nullable=True)
    description = Column(UnicodeText, nullable=True)
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
*/
type Crew struct {
    metas.Crew
    Role string `json:"role" xql:"-"`
}
/*
class AlbumCrew(DeclarativeDeneb):
    __tablename__ = "metas_album_crews"
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    albumId = Column('album_id', UUID,
                     ForeignKey(Album.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                     primary_key=True)
    crewId = Column('crew_id', UUID,
                    ForeignKey(Crew.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                    primary_key=True)
    role = Column('role', String(32), nullable=False, default="actor")
    # }
    crew = relation('Crew', uselist=False)
    album = relation('Album', uselist=False, backref=backref("crews"))
*/
type AlbumCrew struct {
    metas.AlbumCrew
}
/*
class FilmCrew(DeclarativeDeneb):
    __tablename__ = "metas_film_crews"
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    filmId = Column('film_id', UUID,
                    ForeignKey(Film.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                    primary_key=True)
    crewId = Column('crew_id', UUID,
                    ForeignKey(Crew.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                    primary_key=True)
    role = Column('role', String(32), nullable=False, default="actor")
    # }
    crew = relation('Crew', uselist=False)
    film = relation('Film', uselist=False, backref=backref("crews"))
*/
type FilmCrew struct {
    metas.FilmCrew
}
/*
class ScreenShot(DeclarativeDeneb):
    __tablename__ = "metas_film_screenshots"
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    filmId = Column('film_id', UUID,
                    ForeignKey(Film.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                    nullable=False)
    uri = Column(String(256), nullable=False, default="")
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
    film = relation('Film', uselist=False, backref=backref("screenShots"))
*/
type ScreenShot struct {
    metas.ScreenShot
}
/*
class Video(DeclarativeDeneb):
    __tablename__ = 'metas_film_videos'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    definition = Column(String(24), nullable=False, default="SD")
    uri = Column(String(256), nullable=False, default="")
    duration = Column(Integer, nullable=False, default=0)
    filmId = Column('film_id', UUID,
                    ForeignKey(Film.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                    nullable=False)
    mediaType = Column('media_type', String(16), nullable=False, index=True, default="HLS")
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
    film = relation('Film', uselist=False, backref=backref("videos"))
 */
type Video struct {
    metas.Video
}

