package metas

import (
    "time"
)

/*
class Category(DeclarativeDeneb):
    __tablename__ = 'metas_categories'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    categoryName = Column('category_name', Unicode(64), nullable=False, index=True)
    type = Column("type", Integer, nullable=False, default=1)
    index = Column('idx', Integer, nullable=False, default=1)
    icon = Column(String(256), nullable=False, default="")
    description = Column(UnicodeText, nullable=True, default=u"")
    status = Column(SmallInteger, nullable=False, default=0)
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
    filters = relationship('CategoryFilter', uselist=True, order_by="CategoryFilter.index", backref=backref("category"))
*/
type Category struct {
    Id           string `json:"id,omitempty"`
    CategoryName string `json:"categoryName"`
    Type         int `json:"type"`
    Index        int `json:"index"`
    Icon         string `json:"icon"`
    Description  string `json:"description"`
    Status       int16 `json:"status"`
    Created      *time.Time `json:"created"`
    Updated      *time.Time `json:"Updated"`
}
/*
class CategoryFilter(DeclarativeDeneb):
    __tablename__ = 'metas_category_filters'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    filterName = Column('filter_name', Unicode(32), nullable=False, index=True)
    categoryId = Column('category_id', UUID,
                        ForeignKey(Category.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"))
    expression = Column(String(32), nullable=False, default="")  # has_tag, zone, language, genre, genius
    index = Column('idx', Integer, nullable=False, default=1)
    status = Column(SmallInteger, nullable=False, default=0)
    # }
    tags = relationship('CategoryFilterTag',
                        uselist=True,
                        order_by="CategoryFilterTag.index",
                        backref=backref("filter"))
*/
type CategoryFilter struct {
    Id         string `json:"id,omitempty"`
    FilterName string `json:"filterName"`
    CategoryId string `json:"categoryId"`
    Expression string `json:"expression"`
    Index      int `json:"index"`
    Status     int16 `json:"index"`
}
/*
class CategoryFilterTag(DeclarativeDeneb):
    __tablename__ = 'metas_category_filter_tags'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    tagName = Column('tag_name', Unicode(32), nullable=False, index=True)
    filterId = Column('filter_id', UUID,
                      ForeignKey(CategoryFilter.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"))
    index = Column('idx', Integer, nullable=False, default=1)
    value = Column(Unicode(32), nullable=False, default=u"")
    remark = Column(Unicode(128), nullable=False, default=u"")
    # }
*/
type CategoryFilterTag struct {
    Id       string `json:"id,omitempty"`
    TagName  string `json:"tagName"`
    FilterId string `json:"filterId"`
    Index    int `json:"index"`
    Value    string `json:"value"`
    Remark   string `json:"remark"`
}
/*
class CategoryAlbum(DeclarativeDeneb):
    __tablename__ = 'metas_category_albums'
    # {
    # id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    categoryId = Column('category_id', UUID,
                        ForeignKey(Category.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                        primary_key=True)
    albumId = Column('album_id', UUID,
                     ForeignKey(Album.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                     primary_key=True)
    index = Column('idx', Integer, nullable=False, default=0)
    status = Column(SmallInteger, nullable=False, default=0)
    # }
    category = relationship('Category', uselist=False, backref=backref("albums"))
    album = relationship('Album', uselist=False, backref=backref("category_list"))
 */
type CategoryAlbum struct {
    CategoryId string `json:"categoryId"`
    AlbumId    string `json:"albumId"`
    Index      int `json:"index" xql:"idx"`
    Status     int16 `json:"status"`
}