package metas

import (
    "time"
)

/*
class Provider(DeclarativeDeneb):
    __tablename__ = 'metas_providers'
    # {
    id = Column(UUID, primary_key=True, default=func.uuid_generate_v4())
    fullName = Column('full_name', Unicode(64), nullable=False)
    shortName = Column('short_name', Unicode(8), unique=True, nullable=False)
    description = Column(UnicodeText, nullable=True)
    appName = Column('app_name', String(64), nullable=False)
    appKey = Column('app_key', String(64), nullable=False)
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }
*/
type Provider struct {
    Id          string `json:"id,omitempty"`
    FullName    string `json:"fullName"`
    ShortName   string `json:"shortName"`
    Description string `json:"description"`
    AppName     string `json:"appName"`
    AppKey      string `json:"appKey"`
    Created     *time.Time `json:"created"`
    Updated     *time.Time `json:"Updated"`
}
/*
class ProviderCategory(DeclarativeDeneb):
    __tablename__ = 'metas_provider_categories'
    # {
    providerId = Column('provider_id', UUID,
                        ForeignKey(Provider.__tablename__ + '.id', onupdate="CASCADE", ondelete="CASCADE"),
                        primary_key=True)
    categoryId = Column('category_id', UUID, primary_key=True)
    refId = Column("ref_id", String(64), nullable=False)
    allowed = Column('allowed', String(64), nullable=False, default='*')  # ',' seperated methods: CREATE/UPDATE/DELETE
    created = Column(DateTime, nullable=False, default=func.NOW())
    updated = Column(DateTime, nullable=False, default=func.NOW())
    # }

 */
type ProviderCategory struct {
    ProviderId string `json:"providerId"`
    CategoryId string `json:"categoryId"`
    RefId      string `json:"refId"`
    Allowed    string `json:"allowed"`
    Created    *time.Time `json:"created"`
    Updated    *time.Time `json:"Updated"`
}
