package utils

import (
    "errors"
    "encoding/hex"
    "regexp"
    "strings"
)

func EqualBytes(a, b []byte) bool {
    if a == nil && b == nil {
        return true;
    }
    if a == nil || b == nil {
        return false;
    }
    if len(a) != len(b) {
        return false
    }
    for i := range a {
        if a[i] != b[i] {
            return false
        }
    }
    return true
}

func StringInSlice(a string, ls []string) bool {
    for _, s := range ls {
        if a == s {
            return true
        }
    }

    return false
}

func MacAddr2Bytes(mac string) ([]byte, error) {
    b, e := hex.DecodeString(mac)
    if nil != e {
        return nil, e
    }
    if len(b) != 6 {
        return nil, errors.New("Length not match")
    }
    return b, e
}

var camel = regexp.MustCompile("(^[^A-Z]*|[A-Z]*)([A-Z][^A-Z]+|$)")

func Camel2Underscore(s string) string {
    var a []string
    for _, sub := range camel.FindAllStringSubmatch(s, -1) {
        if sub[1] != "" {
            a = append(a, sub[1])
        }
        if sub[2] != "" {
            a = append(a, sub[2])
        }
    }
    return strings.ToLower(strings.Join(a, "_"))
}